// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Describes a Encryption Settings for a Disk
    /// </summary>
    public partial class DiskEncryptionSettings
    {
        /// <summary>
        /// Initializes a new instance of the DiskEncryptionSettings class.
        /// </summary>
        public DiskEncryptionSettings() { }

        /// <summary>
        /// Initializes a new instance of the DiskEncryptionSettings class.
        /// </summary>
        /// <param name="diskEncryptionKey">the disk encryption key which is a
        /// KeyVault Secret.</param>
        /// <param name="keyEncryptionKey">the key encryption key which is
        /// KeyVault Key.</param>
        /// <param name="enabled">whether disk encryption should be enabled on
        /// the Virtual Machine.</param>
        public DiskEncryptionSettings(KeyVaultSecretReference diskEncryptionKey = default(KeyVaultSecretReference), KeyVaultKeyReference keyEncryptionKey = default(KeyVaultKeyReference), bool? enabled = default(bool?))
        {
            DiskEncryptionKey = diskEncryptionKey;
            KeyEncryptionKey = keyEncryptionKey;
            Enabled = enabled;
        }

        /// <summary>
        /// Gets or sets the disk encryption key which is a KeyVault Secret.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "diskEncryptionKey")]
        public KeyVaultSecretReference DiskEncryptionKey { get; set; }

        /// <summary>
        /// Gets or sets the key encryption key which is KeyVault Key.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "keyEncryptionKey")]
        public KeyVaultKeyReference KeyEncryptionKey { get; set; }

        /// <summary>
        /// Gets or sets whether disk encryption should be enabled on the
        /// Virtual Machine.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "enabled")]
        public bool? Enabled { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (this.DiskEncryptionKey != null)
            {
                this.DiskEncryptionKey.Validate();
            }
            if (this.KeyEncryptionKey != null)
            {
                this.KeyEncryptionKey.Validate();
            }
        }
    }
}
