// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Describes a virtual machine scale set network profile's IP
    /// configuration.
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class VirtualMachineScaleSetIPConfigurationInner : Microsoft.Azure.Management.Resource.Fluent.SubResource
    {
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetIPConfigurationInner class.
        /// </summary>
        public VirtualMachineScaleSetIPConfigurationInner() { }

        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetIPConfigurationInner class.
        /// </summary>
        /// <param name="name">the IP configuration name.</param>
        /// <param name="subnet">the subnet.</param>
        /// <param name="applicationGatewayBackendAddressPools">the
        /// application gateway backend address pools.</param>
        /// <param name="loadBalancerBackendAddressPools">the load balancer
        /// backend address pools.</param>
        /// <param name="loadBalancerInboundNatPools">the load balancer
        /// inbound nat pools.</param>
        public VirtualMachineScaleSetIPConfigurationInner(string name, ApiEntityReference subnet, string id = default(string), System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource> applicationGatewayBackendAddressPools = default(System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource>), System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource> loadBalancerBackendAddressPools = default(System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource>), System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource> loadBalancerInboundNatPools = default(System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource>))
            : base(id)
        {
            Name = name;
            Subnet = subnet;
            ApplicationGatewayBackendAddressPools = applicationGatewayBackendAddressPools;
            LoadBalancerBackendAddressPools = loadBalancerBackendAddressPools;
            LoadBalancerInboundNatPools = loadBalancerInboundNatPools;
        }

        /// <summary>
        /// Gets or sets the IP configuration name.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the subnet.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.subnet")]
        public ApiEntityReference Subnet { get; set; }

        /// <summary>
        /// Gets or sets the application gateway backend address pools.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.applicationGatewayBackendAddressPools")]
        public System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource> ApplicationGatewayBackendAddressPools { get; set; }

        /// <summary>
        /// Gets or sets the load balancer backend address pools.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.loadBalancerBackendAddressPools")]
        public System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource> LoadBalancerBackendAddressPools { get; set; }

        /// <summary>
        /// Gets or sets the load balancer inbound nat pools.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.loadBalancerInboundNatPools")]
        public System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource> LoadBalancerInboundNatPools { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Name");
            }
            if (Subnet == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Subnet");
            }
        }
    }
}
