// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Request parameters for create a new group
    /// </summary>
    public partial class GroupCreateParametersInner
    {
        /// <summary>
        /// Initializes a new instance of the GroupCreateParametersInner class.
        /// </summary>
        public GroupCreateParametersInner() { }

        /// <summary>
        /// Initializes a new instance of the GroupCreateParametersInner class.
        /// </summary>
        /// <param name="displayName">Group display name</param>
        /// <param name="mailNickname">Mail nick name</param>
        public GroupCreateParametersInner(string displayName, string mailNickname)
        {
            DisplayName = displayName;
            MailNickname = mailNickname;
        }
        /// <summary>
        /// Static constructor for GroupCreateParametersInner class.
        /// </summary>
        static GroupCreateParametersInner()
        {
            MailEnabled = false;
            SecurityEnabled = true;
        }

        /// <summary>
        /// Gets or sets group display name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets mail nick name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "mailNickname")]
        public string MailNickname { get; set; }

        /// <summary>
        /// Specifies whether the group is mail-enabled. Must be false. This
        /// is because only pure security groups can be created using the
        /// Graph API.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "mailEnabled")]
        public static bool MailEnabled { get; private set; }

        /// <summary>
        /// Specifies whether the group is a security group. Must be true.
        /// This is because only pure security groups can be created using
        /// the Graph API.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "securityEnabled")]
        public static bool SecurityEnabled { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (DisplayName == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "DisplayName");
            }
            if (MailNickname == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "MailNickname");
            }
        }
    }
}
