// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Active Directory Key Credential information
    /// </summary>
    public partial class KeyCredential
    {
        /// <summary>
        /// Initializes a new instance of the KeyCredential class.
        /// </summary>
        public KeyCredential() { }

        /// <summary>
        /// Initializes a new instance of the KeyCredential class.
        /// </summary>
        /// <param name="startDate">start date</param>
        /// <param name="endDate">end date</param>
        /// <param name="value">value</param>
        /// <param name="keyId">key Id</param>
        /// <param name="usage">usage. Acceptable values are 'Verify' and
        /// 'Sign'.</param>
        /// <param name="type">type. Acceptable values are
        /// 'AsymmetricX509Cert' and 'Symmetric'.</param>
        public KeyCredential(System.DateTime? startDate = default(System.DateTime?), System.DateTime? endDate = default(System.DateTime?), string value = default(string), string keyId = default(string), string usage = default(string), string type = default(string))
        {
            StartDate = startDate;
            EndDate = endDate;
            Value = value;
            KeyId = keyId;
            Usage = usage;
            Type = type;
        }

        /// <summary>
        /// Gets or sets start date
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "startDate")]
        public System.DateTime? StartDate { get; set; }

        /// <summary>
        /// Gets or sets end date
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "endDate")]
        public System.DateTime? EndDate { get; set; }

        /// <summary>
        /// Gets or sets value
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Gets or sets key Id
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "keyId")]
        public string KeyId { get; set; }

        /// <summary>
        /// Gets or sets usage. Acceptable values are 'Verify' and 'Sign'.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "usage")]
        public string Usage { get; set; }

        /// <summary>
        /// Gets or sets type. Acceptable values are 'AsymmetricX509Cert' and
        /// 'Symmetric'.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

    }
}
