// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Active Directory service principal information
    /// </summary>
    public partial class ServicePrincipalInner
    {
        /// <summary>
        /// Initializes a new instance of the ServicePrincipalInner class.
        /// </summary>
        public ServicePrincipalInner() { }

        /// <summary>
        /// Initializes a new instance of the ServicePrincipalInner class.
        /// </summary>
        /// <param name="objectId">object Id</param>
        /// <param name="objectType">object type</param>
        /// <param name="displayName">service principal display name</param>
        /// <param name="appId">app id</param>
        /// <param name="servicePrincipalNames">the list of names.</param>
        public ServicePrincipalInner(string objectId = default(string), string objectType = default(string), string displayName = default(string), string appId = default(string), System.Collections.Generic.IList<string> servicePrincipalNames = default(System.Collections.Generic.IList<string>))
        {
            ObjectId = objectId;
            ObjectType = objectType;
            DisplayName = displayName;
            AppId = appId;
            ServicePrincipalNames = servicePrincipalNames;
        }

        /// <summary>
        /// Gets or sets object Id
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "objectId")]
        public string ObjectId { get; set; }

        /// <summary>
        /// Gets or sets object type
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "objectType")]
        public string ObjectType { get; set; }

        /// <summary>
        /// Gets or sets service principal display name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets app id
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "appId")]
        public string AppId { get; set; }

        /// <summary>
        /// Gets or sets the list of names.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "servicePrincipalNames")]
        public System.Collections.Generic.IList<string> ServicePrincipalNames { get; set; }

    }
}
