// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// DHCPOptions contains an array of DNS servers available to VMs deployed
    /// in the virtual networkStandard DHCP option for a subnet overrides
    /// VNET DHCP options.
    /// </summary>
    public partial class DhcpOptions
    {
        /// <summary>
        /// Initializes a new instance of the DhcpOptions class.
        /// </summary>
        public DhcpOptions() { }

        /// <summary>
        /// Initializes a new instance of the DhcpOptions class.
        /// </summary>
        /// <param name="dnsServers">Gets or sets list of DNS servers IP
        /// addresses</param>
        public DhcpOptions(System.Collections.Generic.IList<string> dnsServers = default(System.Collections.Generic.IList<string>))
        {
            DnsServers = dnsServers;
        }

        /// <summary>
        /// Gets or sets list of DNS servers IP addresses
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "dnsServers")]
        public System.Collections.Generic.IList<string> DnsServers { get; set; }

    }
}
