// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Storage.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// The URIs that are used to perform a retrieval of a public blob, queue
    /// or table object.
    /// </summary>
    public partial class Endpoints
    {
        /// <summary>
        /// Initializes a new instance of the Endpoints class.
        /// </summary>
        public Endpoints() { }

        /// <summary>
        /// Initializes a new instance of the Endpoints class.
        /// </summary>
        /// <param name="blob">Gets the blob endpoint.</param>
        /// <param name="queue">Gets the queue endpoint.</param>
        /// <param name="table">Gets the table endpoint.</param>
        /// <param name="file">Gets the file endpoint.</param>
        public Endpoints(string blob = default(string), string queue = default(string), string table = default(string), string file = default(string))
        {
            Blob = blob;
            Queue = queue;
            Table = table;
            File = file;
        }

        /// <summary>
        /// Gets the blob endpoint.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "blob")]
        public string Blob { get; private set; }

        /// <summary>
        /// Gets the queue endpoint.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "queue")]
        public string Queue { get; private set; }

        /// <summary>
        /// Gets the table endpoint.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "table")]
        public string Table { get; private set; }

        /// <summary>
        /// Gets the file endpoint.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "file")]
        public string File { get; private set; }

    }
}
